#ifndef __MOUSUTIL_H
#define __MOUSUTIL_H

#ifndef BYTE
  #define BYTE unsigned char
#endif

#ifndef WORD
  #define WORD unsigned int
#endif

#ifndef LWORD
  #define LWORD unsigned long int
#endif


#define MOUSINT        0x33

#define MOUS_LBUT      0x00
#define MOUS_RBUT      0x01
#define MOUS_CBUT      0x02

#define MOUS_LBUT_ON   0x01
#define MOUS_RBUT_ON   0x02
#define MOUS_CBUT_ON   0x04

#define TRAP_NONE      0x00
#define CURSOR_CHANGE  0x01
#define LBUT_PRS       0x02
#define LBUT_REL       0x04
#define LBUT_CHANGE    (LBUT_PRS+LBUT_REL)
#define RBUT_PRS       0x08
#define RBUT_REL       0x10
#define RBUT_CHANGE    (RBUT_PRS+RBUT_REL)
#define MBUT_PRS       0x20
#define MBUT_REL       0x40
#define MBUT_CHANGE    (MBUT_PRS+MBUT_REL)
#define TRAP_ALL       0x7F


typedef void (*MOUSTRAP)(
  int event,
  int button,
  int x,
  int y,
  int xcnts,
  int ycnts
);

typedef struct MOUS_struct {
  WORD butstat;
  WORD row;
  WORD col;
  WORD butcnt;
} MOUS;


int  mousinit(void);
void mousshow(void);
void moushide(void);
void mousset(int show);
int  mousgetall(MOUS *m);
int  mousgetbut(void);
int  mousgetrow(void);
int  mousgetcol(void);
int  moussetall(MOUS *m);
int  moussetcpos(int row,int col);
int  moussetrow(int row);
int  moussetcol(int col);
int  mousgetprs(WORD but,MOUS *m);
int  mousgetrel(WORD but,MOUS *m);
int  mouscurstype(WORD and,WORD xor);
int  moushwcurs(WORD start,WORD stop);
int moustrap(int event,MOUSTRAP func);

#endif                     /*if [mousutil.h] not already included*/
